include	clib.inc
include	io.inc
include	string.inc
include	iost.inc

	.186

ifdef __ZIP__
	extrn odecrypt: NEAR
endif
	public	ofread
	public	oupdate

_TEXT	SEGMENT

ofread	PROC	DIST
	push	si
	push	di
	mov	si,STDI.ios_flag
  ifdef __MIO__
	test	si,IO_MEMREAD
	jnz	ofread_memory
  endif
	mov	di,STDI.ios_c
	sub	di,STDI.ios_i
	jnz	ofread_copy
    ofread_read:
	xor	ax,ax
	mov	STDI.ios_i,ax
	mov	STDI.ios_c,di
	mov	cx,STDI.ios_size
	sub	cx,di
	push	ds
	mov	bx,STDI.ios_file
	lds	dx,STDI
	add	dx,di
	mov	ax,3F00h
	int	21h
	pop	ds
	jc	ofread_error
	add	STDI.ios_c,ax
	add	ax,di
	and	si,IO_UPDTOTAL or IO_USECRC or IO_USEUPD or IO_CRYPT
	jnz	ofread_user
    ofread_end:
	or	ax,ax
	pop	di
	pop	si
	ret
  ifdef __MIO__
    ofread_memory:
	call	iomemread
	jmp	ofread_end
  endif
    ofread_user:
  ifdef __ZIP__
	test	si,IO_CRYPT
	jz	ofread_total
	call	odecrypt
  endif
    ofread_total:
	test	si,IO_UPDTOTAL
	jz	ofread_crc
	add	STDI.ios_total_ax,ax
	adc	STDI.ios_total_dx,0
    ofread_crc:
	test	si,IO_USECRC
	jz	ofread_progress
	mov	dx,di
	mov	si,OSTDI
	call	oupdcrc
	mov	si,STDI.ios_flag
    ofread_progress:
	test	si,IO_USEUPD
	jz	ofread_end
	push	ax
	push	0
	call	oupdate
	dec	ax
	pop	ax
	jnz	ofread_eof
	jmp	ofread_end
    ofread_copy:
	cmp	di,STDI.ios_c
	je	ofread_eof
	mov	dx,STDI.ios_bp_dx
	mov	ax,STDI.ios_bp_ax
	push	dx
	push	ax
	push	dx
	add	ax,STDI.ios_i
	push	ax
	push	di
	call	memcpy
	jmp	ofread_read
    ofread_error:
	call	@dosmaper
	or	STDI.ios_flag,IO_ERROR
    ofread_eof:
	xor	ax,ax
	jmp	ofread_end
ofread	ENDP

ifdef __MIO__

iomemread PROC
	mov	ax,WORD PTR tvmem_offs
	mov	dx,WORD PTR tvmem_offs+2
	mov	bx,STDI.ios_offset_ax
	mov	cx,STDI.ios_offset_dx
	add	bx,ax
	adc	cx,dx
	add	ax,WORD PTR tvmem_size
	adc	dx,WORD PTR tvmem_size+2
	cmp	cx,dx
	jne	iomemread_00
	cmp	bx,ax
    iomemread_00:
	jae	iomemread_02
	push	STDI.ios_bp_dx
	push	STDI.ios_bp_ax
	sub	ax,bx
	sbb	dx,cx
	mov	di,bx
	and	di,000Fh
	and	bl,0F0h
	mov	ch,cl
	mov	cl,bh
	mov	si,4
	xchg	cx,si
	shl	si,cl
	shr	bl,cl
	xchg	cx,si
	or	cl,bl
	push	cx
	push	di
	mov     cx,STDI.ios_size
	push	cx
	or	dx,dx
	jnz	iomemread_01
	cmp	cx,ax
	jb	iomemread_01
	mov	cx,ax
    iomemread_01:
	mov	STDI.ios_c,cx
	add	STDI.ios_offset_ax,cx
	adc	STDI.ios_offset_dx,0
	xor	ax,ax
	mov	STDI.ios_i,ax
	call	memcpy
	mov	ax,1
	ret
    iomemread_02:
	mov	STDI.ios_offset_ax,ax
	mov	STDI.ios_offset_dx,dx
	xor	ax,ax
	mov	STDI.ios_i,ax
	mov	STDI.ios_c,ax
	ret
iomemread ENDP
endif

_TEXT	ENDS

_DATA	SEGMENT
oupdate	PF	0
_DATA	ENDS

	END
